mongoose = require('mongoose').set('debug', false)
const Schema = mongoose.Schema;

const tools = require('../tools/general');

mongoose.Promise = global.Promise;
mongoose.level = "F";


// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const storehouseSchema = new Schema({
  idapp: {
    type: String,
  },
  name: {
    type: String,
    required: true,
  },
  username: {
    type: String,
  },
  groupname: {
    type: String,
  },
  description: {
    type: String,
  },
  referent: {
    type: String,
  },
  address: {
    type: String,
  },
  city: {
    type: String,
  },
  region: {
    type: String,
  },
  img: {
    type: String,
  },
  website: {
    type: String,
  },
  email_html_header: {
    type: String,
    default: '',
  },
  email_html_footer: {
    type: String,
    default: '',
  },
  email_html_makeorder: {
    type: String,
    default: '',
  },
  email_html_order_confirmed: {
    type: String,
    default: '',
  },
  email_html_order_consegnato: {
    type: String,
    default: '',
  },
  email_html_GAS_makeorder: {
    type: String,
    default: '',
  },
  email_html_GAS_order_confirmed: {
    type: String,
    default: '',
  },
  email_html_GAS_order_consegnato: {
    type: String,
    default: '',
  },
});

var Storehouse = module.exports = mongoose.model('Storehouse', storehouseSchema);

module.exports.getFieldsForSearch = function () {
  return [{ field: 'name', type: tools.FieldType.string }]
};

module.exports.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, idapp, params);
};

module.exports.findAllIdApp = async function (idapp) {
  const myfind = { idapp };

  return await Storehouse.find(myfind);
};

module.exports.createIndexes()
  .then(() => { })
  .catch((err) => { throw err; });

